#!/usr/local/bin/wish -f

#charles vidal 1998 <vidalc@club-internet.fr>

#nombre total d'ecran dans l'assistant
set nbtotalecran  3 
set nbcreatelabel 0
set nbcreateentry 0
set nbcreatelist  0
set nbcreateradio 0
set nbcreatecheck 0
set nbcreatescale 0
set nbframe 0
set titreassist "Make Assistant"
set nbtextvar ""

set windtmp ""
set opt     ""

set tmpfnt ""
global tmpfnt
# Add for laetOS thank to guylhem@danmark.linux.eu.org (Guylhem AZNAR)
#source "fvwm2.tcl"
# the first proc call to change the  title
proc ChangeStr { w opt } {

global windtmp
global opttmp
toplevel .changestr
set windtmp $w
set opttmp $opt
global nb_ecran
set str ""

entry .changestr.e1 -textvariable str 
.changestr.e1 delete 0 end
.changestr.e1 insert 0 [ $windtmp cget -$opt ]
pack .changestr.e1 

button .changestr.bclose -text "Fermer" -command "destroy .changestr"
button .changestr.detruit -text "Detruire wigdet" -command {
						destroy $windtmp
						destroy .changestr
						}
						
button .changestr.applic -text "Appliquer" -command {
					$windtmp configure  -text $str
					destroy .changestr
						}
	pack .changestr.bclose .changestr.applic .changestr.detruit -side left
after 100 {
    grab .changestr
	}

	bind .changestr.e1  <Return> {
		$windtmp configure  -$opttmp $str
		destroy .changestr
	}
}

proc opencolorsel { var  } {
upvar $var toto
set toto [tk_chooseColor -title "Choix de la couleur"]
}

proc openfilesel { var  } {
upvar $var toto
set toto [ tk_getOpenFile -parent .]
puts $toto
}

proc openfont { var } {
upvar $var toto
global tmpfnt
     toplevel .font 
     set Fnt .font
	wm title $Fnt "Font Options"
	label  $Fnt.label -text "ABCDEFGH\nIJKabedfg\nhijkmnopq" 
    frame $Fnt.frame -borderwidth 10 
    frame $Fnt.frame2 -borderwidth 10
    set w $Fnt.frame
    label $w.msg0   -text "Font Options" 
    pack $w.msg0 -side top
    eval exec "xlsfonts \> /tmp/xlsfont.tmp"
    set f [open "/tmp/xlsfont.tmp"]
    listbox $Fnt.frame.names -yscrollcommand ".font.frame.scroll set" \
	-xscrollcommand "$Fnt.scroll2 set"  -setgrid 1 \
         -exportselection false 
    bind $Fnt.frame.names <Double-1> {
            .font.test configure -font [.font.frame.names get [.font.frame.names curselection]]
    set tmpfnt  [.font.frame.names get [.font.frame.names curselection]]
    }
    scrollbar $Fnt.frame.scroll -orient vertical -command ".font.frame.names yview" \
            -relief sunken -borderwidth 2
    scrollbar $Fnt.scroll2 -orient horizontal -command "$Fnt.frame.names xview" \
            -relief sunken -borderwidth 2
    while {[gets $f line] >= 0} {
            $Fnt.frame.names insert end $line 
    }
    close $f

    eval exec "/bin/rm -f /tmp/xlsfont.tmp"
    pack $Fnt.frame.names  -side left -expand y -fill both
    pack $Fnt.frame.scroll -side right -fill both
    pack $Fnt.frame  -fill x
    pack $Fnt.scroll2 -fill both
	label  $Fnt.test -text "ABCDEFGHIJKabedfghijkmnopq12345" 
        pack $Fnt.test

    button $Fnt.frame2.cancel -text Cancel -command "destroy $Fnt"
    button $Fnt.frame2.ok -text OK -command "set $var $tmpfnt; destroy $Fnt"
	pack $Fnt.frame2.ok $Fnt.frame2.cancel  -side left -fill both
	pack $Fnt.frame2 -fill both
}

proc GetStr { }  {
toplevel .getstr
global titreassist
global nb_ecran
entry .getstr.e1 -textvariable titreassist
pack .getstr.e1 
button .getstr.bclose -text "Fermer" -command "destroy .getstr"
pack .getstr.bclose
after 100 {
    grab .getstr
	}
bind .getstr.e1  <Return> {
		.f$nb_ecran.lt$nb_ecran configure  -text $titreassist
		destroy .getstr
	}
}
proc InputEcran { n } {
 switch -- $n {
	0 { 
		}
	1 {
		}
	}
}
proc OutputEcran { n } {
 switch -- $n {
	0 { 
		}
	1 {
		}
	}
}
# Generation code 
proc sortie { } {
global nbtotalecran
global nbframe
global nbtextvar
set nb_ecran 0
set namefile [tk_getSaveFile -parent .]
set f [open $namefile w]
puts $f "# generated vidal@club-internet.fr "
puts $f "proc action \{ \} \{\n \}"
puts $f "set nbtotalecran $nbtotalecran"
puts $f "source fassist.tcl"
 for { set  i  0 } { $i < $nbtotalecran } { incr i 1 } {
	puts  $f "creationscreennb  $i \"[.f$i.lt$i cget -text ]\" \"[.f$i.mesg cget -text ]\""
	set allwin [winfo children .f$i]
	puts $f "mkecran $i \\"
	foreach a $allwin {
		switch -regexp $a { 
			.f[0-9]+\.list[0-9]+ {
						puts $f "\{LIST \} \\"
						}
			.f[0-9]+\.label[0-9]+ {
				 puts  $f "\{LABEL \"[ $a cget -text ]\" \}\\" }
			.f[0-9]+\.edit[0-9]+ { 
				puts $f "\{EDIT puts $f  [ $a cget -text ] editvar$nbtextvar \}\\"
			 	set nbtextvar [ expr $nbtextvar + 1 ] 
				}
			.f[0-9]+\.check[0-9]+ { 
				puts $f "\{CHECK \"[ $a cget -text ]\" \"variable\" \"onvalue\" \"offvalue\"\}\\" 
				}
			.f[0-9]+\.radio[0-9]+ { 
				puts $f "\{RADIO \"[ $a cget -text ]\" \}\\" 
				}
			.f[0-9]+\.scale[0-9]+ { 
				puts $f "\{SCALE 0 100\}\\" 
				}
			.f[0-9]+\.frame[0-9]+ { 
				puts $f "\{FILE \"[ $a.label cget -text]\" val$nbtextvar \"\"\}\\"
			 set nbtextvar [ expr $nbtextvar + 1 ] }
			.f[0-9]+\.fcolor[0-9]+ {
				 puts $f "\{COLOR \"[ $a.label cget -text]\" color$nbtextvar Color black\}\\" 
			 set nbtextvar [ expr $nbtextvar + 1 ] }
				.f[0-9]+\.ffnt[0-9]+ {
					 puts $f "\{FONT \"[ $a.label cget -text]\" val$nbtextvar fontvar$nbtextvar\}\\"
			 set nbtextvar [ expr $nbtextvar + 1 ] }
		}
	   }
	puts $f " \{ \}  "
	}
puts $f "source \"fassist2.tcl\""
}
#
# Creation of widget addxxxx ( name of widget )
#

proc addscale { } {
global nb_ecran
global nbcreatescale
global list$nb_ecran
scale .f$nb_ecran.scale$nbcreatescale -orient horizontal -label scale$nbcreatescale
bind  .f$nb_ecran.scale$nbcreatescale <Double-1> { ChangeStr %W label }
pack .f$nb_ecran.scale$nbcreatescale
set nbcreatescale [expr $nbcreatescale + 1]
}
proc addcheck { } {
global nb_ecran
global nbcreatecheck
set w .f$nb_ecran
checkbutton $w.check$nbcreatecheck -text "check$nbcreatecheck"
pack $w.check$nbcreatecheck
bind  $w.check$nbcreatecheck <Double-1> { ChangeStr %W text}
set nbcreatecheck [expr $nbcreatecheck + 1]
}
proc entryfile { } {
global nbframe
global nb_ecran
global nbtextvar
 frame  .f$nb_ecran.frame$nbframe
 set w .f$nb_ecran.frame$nbframe
 label $w.label  -text "Double Cliquez pour changer" 
 bind   $w.label <Double-1> { ChangeStr %W text}
 entry  $w.entry  -textvariable textvar$nbtextvar
 button $w.button -text "File" -command "openfilesel textvar$nbtextvar"
 pack $w 
 pack  $w.label $w.entry $w.button  -side left
 set nbtextvar [ expr $nbtextvar + 1 ]
 set nbframe [expr $nbframe + 1]
}

proc entrycolor { } {
global nbframe
global nb_ecran
global nbtextvar
        frame  .f$nb_ecran.fcolor$nbframe
	set w .f$nb_ecran.fcolor$nbframe
        label $w.label  -text "Double Cliquez pour changer" 
	bind   $w.label <Double-1> { ChangeStr %W text}
        entry  $w.entry  -textvariable textvar$nbtextvar
        button $w.button -text "Color" -command "opencolorsel  textvar$nbtextvar"
        pack $w 
        pack  $w.label $w.entry $w.button  -side left
set nbtextvar [ expr $nbtextvar + 1 ]
set nbframe [expr $nbframe + 1]
}
proc entryfont { } {
global nbframe
global nb_ecran
global nbtextvar
        frame  .f$nb_ecran.ffnt$nbframe
	set w .f$nb_ecran.ffnt$nbframe
        label $w.label  -text "Double Cliquez pour changer" 
	bind   $w.label <Double-1> { ChangeStr %W text}
        entry  $w.entry  -textvariable textvar$nbtextvar
        button $w.button -text "Font" -command "openfont textvar$nbtextvar"
        pack $w 
        pack  $w.label $w.entry $w.button  -side left
set nbtextvar [ expr $nbtextvar + 1 ]
set nbframe [expr $nbframe + 1]
}

proc addchech { } {
global nb_ecran
global nbcreatecheck
checkbutton .f$nb_ecran.check$nbcreatecheck -text "check$nbcreatecheck"
pack .f$nb_ecran.check$nbcreatecheck
bind  .f$nb_ecran.check$nbcreatecheck <Double-1> { ChangeStr %W text}
set nbcreatecheck [expr $nbcreatecheck + 1]
}

proc addradio { } {
global nb_ecran
global nbcreateradio
radiobutton .f$nb_ecran.radio$nbcreateradio -text "radio$nbcreateradio"
pack .f$nb_ecran.radio$nbcreateradio
bind  .f$nb_ecran.radio$nbcreateradio <Double-1> { ChangeStr %W text}
set nbcreateradio [expr $nbcreateradio + 1]
}

proc addlist { } {
global nb_ecran
global nbcreatelist
listbox .f$nb_ecran.list$nbcreatelist -height 3
pack .f$nb_ecran.list$nbcreatelist
set nbcreatelist [expr $nbcreatelist + 1]
}

proc addedit { } {
global nb_ecran
global nbcreateentry
entry .f$nb_ecran.edit$nbcreateentry -textvariable editvar$nbcreateentry 
pack .f$nb_ecran.edit$nbcreateentry
set nbcreateentry [expr $nbcreateentry + 1]
}

proc addlabel { } {
global nb_ecran
global nbcreatelabel
label .f$nb_ecran.label$nbcreatelabel -text "Label $nbcreatelabel"
pack .f$nb_ecran.label$nbcreatelabel
bind  .f$nb_ecran.label$nbcreatelabel <Double-1> { ChangeStr %W text}
set nbcreatelabel [expr $nbcreatelabel + 1]
}
proc addscreen { } {
upvar nbtotalecran nb
set nb  [expr $nb + 1]
creationscreennb  $nb "Double cliquer sur moi pour me changer $nb" { }
}
proc prec_ecran { } {
global nb_ecran
set tmp [expr $nb_ecran - 1]
if { $tmp > -1} {
		OutputEcran $nb_ecran
		pack forget .f$nb_ecran
		InputEcran $nb_ecran
		set nb_ecran [expr $nb_ecran - 1]
		pack .f$nb_ecran 
		}
}
proc next_ecran { } {
global nb_ecran
global nbtotalecran
set tmp [expr $nb_ecran + 1]
if { $tmp < $nbtotalecran} {
		OutputEcran $nb_ecran
		pack forget .f$nb_ecran
		InputEcran $nb_ecran
		set nb_ecran [expr $nb_ecran + 1]
		pack .f$nb_ecran 
		}
}
proc changetitre { } {
global nb_ecran
global titreassist
global varstr
ChangeStr .f$nb_ecran.lt$nb_ecran text
}
proc creationscreennb { n title desc} {
global titreassist
set currentarg 0
frame .f$n 
label .f$n.lt$n -text "$title" -font -adobe-courier-bold-*-*-*-18-*-*-*-*-*-*-* 
bind  .f$n.lt$n  <Double-1> changetitre
pack .f$n.lt$n 
message .f$n.mesg -text $desc -width 15c
bind  .f$n.mesg  <Double-1>  { ChangeStr %W text } 
pack .f$n.mesg
}

# main 
#puts  $argc
if { $argc > 0 } {
	set nbtotalecran [lindex $argv 0]
	}
# Ecran du debut
# Creation of GUI 
global nb_ecran
set nb_ecran 0
wm title . $titreassist
for {set i 0} {$i <= $nbtotalecran} {incr i} {
creationscreennb  $i "Double cliquer sur moi pour me changer $i" {Ceci est une description }
}
toplevel .add
frame .add.fa
set F .add.fa
button $F.addsc -text "add screen" -command "addscreen"
button $F.adde -text "add entry" -command "addedit"
button $F.addl -text "add label" -command "addlabel"
button $F.addli -text "add List" -command "addlist"
button $F.addr -text "add Radio" -command "addradio"
button $F.addc -text "add check" -command "addcheck"
button $F.adds -text "add scale" -command "addscale"
button $F.addsel -text "add file entry" -command "entryfile"
button $F.addcol -text "add color entry" -command "entrycolor"
button $F.addfnt -text "add font entry" -command "entryfont"
pack $F.addli $F.adde $F.addl $F.addc $F.addr $F.adds $F.addsc $F.addsel $F.addcol $F.addfnt 
frame .f 

button .f.b1 -text "precedent" -command "prec_ecran"
button .f.b2 -text "suivant" -command "next_ecran"
button .f.b3 -text "Sortie tcl-tk" -command "sortie"
#button .f.b4 -text "Sortie fvwm2script" -command "sortiefvwm"
button .f.quit -text "Quitter" -command "exit"

pack .f.b1 .f.b2 .f.b3 .f.quit -side left
pack .f -side bottom

pack .f$nb_ecran -fill y -expand yes -side top
pack $F 
