#charles vidal 1997 <cvidal@newlog.com>
# titre de l'assistant
set titleassist "Assistant xxxx"

set tmpfnt ""

global tmpfnt

# nombre total d'ecran
#set nbtotalecran 6

# Declaration des variables globales
set nbwidget 0

# numero de l'ecran courant
set nb_ecran 0


proc openfont { var } {
upvar $var toto
global tmpfnt
     toplevel .font 
     set Fnt .font
	wm title $Fnt "Font Options"
	label  $Fnt.label -text "ABCDEFGH\nIJKabedfg\nhijkmnopq" 

    frame $Fnt.frame -borderwidth 10 
    frame $Fnt.frame2 -borderwidth 10
    set w $Fnt.frame
    label $w.msg0   -text "Font Options" 
    pack $w.msg0 -side top
    eval exec "xlsfonts \> /tmp/xlsfont.tmp"
    set f [open "/tmp/xlsfont.tmp"]
    listbox $Fnt.frame.names -yscrollcommand ".font.frame.scroll set" \
	-xscrollcommand "$Fnt.scroll2 set"  -setgrid 1 \
         -exportselection false 
    bind $Fnt.frame.names <Double-1> {
            .font.test configure -font [.font.frame.names get [.font.frame.names curselection]]
    set tmpfnt  [.font.frame.names get [.font.frame.names curselection]]
    }
    scrollbar $Fnt.frame.scroll -orient vertical -command ".font.frame.names yview" \
            -relief sunken -borderwidth 2
    scrollbar $Fnt.scroll2 -orient horizontal -command "$Fnt.frame.names xview" \
            -relief sunken -borderwidth 2
    while {[gets $f line] >= 0} {
            $Fnt.frame.names insert end $line 
    }
    close $f

    eval exec "/bin/rm -f /tmp/xlsfont.tmp"
    pack $Fnt.frame.names  -side left -expand y -fill both
    pack $Fnt.frame.scroll -side right -fill both
    pack $Fnt.frame  -fill x
    pack $Fnt.scroll2 -fill both
	label  $Fnt.test -text "ABCDEFGHIJKabedfghijkmnopq12345" 
        pack $Fnt.test

    button $Fnt.frame2.cancel -text Cancel -command "destroy $Fnt"
    button $Fnt.frame2.ok -text OK -command "set $var $tmpfnt; destroy $Fnt"
	pack $Fnt.frame2.ok $Fnt.frame2.cancel  -side left -fill both
	pack $Fnt.frame2 -fill both
}
proc opencolorsel {titre  var wf } {
upvar $var toto
set toto [tk_chooseColor -title $titre]
 $wf.label configure -foreground $toto
}
proc openfilesel { var  } {
upvar $var toto
set toto [ tk_getOpenFile -parent .]
}

proc OutputEcran { n } { 
global nomuser 
global nomreel 
global homedir 
 switch  $n { 
	}
}

proc InputEcran { n } {
global nomuser 
global homedir
 switch  $n {
	}
}

# Callback pour revenir a l'ecran precedent
proc prec_ecran { } {
global nbtotalecran
global nb_ecran
set tmp [expr $nb_ecran - 1]
if { $tmp > -1} {
		OutputEcran $nb_ecran
		pack forget .f$nb_ecran
		set nb_ecran [expr $nb_ecran - 1]
		InputEcran $nb_ecran
		pack .f$nb_ecran 
		}
if { $nb_ecran != [expr $nbtotalecran - 1 ]}  {
		.f.b3 configure -text "Annuler"
		}
}

# Callback pour aller a l'ecran suivant
proc next_ecran { } {
global nb_ecran
global nbtotalecran
if { $nb_ecran == [expr $nbtotalecran - 1 ]}  {
		.f.b3 configure -text "Terminer"
		}
if { $nb_ecran != [expr $nbtotalecran - 1 ]}  {
		.f.b3 configure -text "Annuler"
		}
set tmp [expr $nb_ecran + 1]
if { $tmp < $nbtotalecran} {
		OutputEcran $nb_ecran
		pack forget .f$nb_ecran
		set nb_ecran [expr $nb_ecran + 1]
		InputEcran $nb_ecran
		pack .f$nb_ecran 
		}
}

# Creation du label titre et du texte explicatif
# Argument n:numero de l'ecran title:titre desc description

proc creationscreennb { n title desc} {
set currentarg 0
frame .f$n -height 10 -width 10
label .f$n.lt$n -text $title -font -Adobe-Courier-Bold-R-Normal-*-140-*
pack .f$n.lt$n 
frame .f$n.fdesc 
message  .f$n.mesg -text $desc -width 25c
pack .f$n.mesg -fill x
pack .f$n.fdesc
}

# Creation de deux label + entry avec variable texte
# Argument n:numero de l'ecran label1:label devant texte vtext1:variable text
# De meme pour les xxxx2

proc creationentry { n nbf  text variable value} {
	frame .f$n.fr$nbf
	label .f$n.fr$nbf.lab1 -text $text
	entry .f$n.fr$nbf.e1 -textvariable  $variable
	.f$n.fr$nbf.e1 insert 0 $value
	pack .f$n.fr$nbf 
	pack .f$n.fr$nbf.e1  -side right
	pack .f$n.fr$nbf.lab1  -side left
}

proc mkecran { n args } {
  global nbwidget
  set nbf 0
  set w  .f$n
  foreach i $args {
		switch -regexp  [lindex $i 0] {
				LIST { listbox  $w.list$nbwidget 
					pack  $w.list$nbwidget 
					}
				ENTRY { 
					creationentry  $n $nbwidget [lindex $i 1] [lindex $i 2] [lindex $i 3] 
					}
				LABEL { label  $w.label$nbwidget -text  [lindex $i 1]
					pack  $w.label$nbwidget
					}
				CHECK { checkbutton  $w.check$nbwidget -text  [lindex $i 1] -variable  [lindex $i 2] -onvalue  [lindex $i 3] -offvalue [lindex $i 4]
					pack  $w.check$nbwidget 
					}
				RADIO { radiobutton  $w.radio$nbwidget -text  [lindex $i 1] -variable  [lindex $i 2]
					pack  $w.radio$nbwidget
					}
				BUTTON { button  $w.button$nbwidget -text  [lindex $i 1]
					pack  $w.button$nbwidget 
					}
				SCALE { scale  $w.scale$nbwidget -from [lindex $i 1] -to [lindex $i 2]  -orient horizontal 
					pack  $w.scale$nbwidget 
					}
				FILE { 
        				frame   $w.frame$nbwidget
        				set  wf $w.frame$nbwidget
        				label   $wf.label  -text [lindex $i 1]
        				entry   $wf.entry  -textvariable [lindex $i 2 ]
	 				$wf.entry insert 0 [lindex $i 3] 
        				button $wf.button -text "File" -command "openfilesel [lindex $i 2]"
        				pack $wf
        				pack  $wf.label $wf.entry $wf.button  -side left
					}
				COLOR { 
        				frame   $w.frame$nbwidget
        				set  wf $w.frame$nbwidget
					if { [lindex $i 4] !="" } then { label $wf.label  -text [lindex $i 1] -foreground [lindex $i 4] 
					} else { label $wf.label  -text [lindex $i 1] }
        				entry   $wf.entry  -textvariable [lindex $i 2 ]
	 				$wf.entry insert 0 [lindex $i 4] 
        				button $wf.button -text "Color" -command "opencolorsel [lindex $i 3] [lindex $i 2] $wf"
        				pack $wf
        				pack  $wf.label $wf.entry $wf.button  -side left
					}
				FONT { 
        				frame   $w.frame$nbwidget
        				set  wf $w.frame$nbwidget
        				label   $wf.label  -text [lindex $i 1]
        				entry   $wf.entry  -textvariable [lindex $i 2 ]
	 				$wf.entry insert 0 [lindex $i 3] 
        				button $wf.button -text "Font" -command "openfont [lindex $i 2] "
        				pack $wf
        				pack  $wf.label $wf.entry $wf.button  -side left
					}
				}
	set nbwidget [expr $nbwidget + 1]
		}
}
# 
